"use strict";

// Transient messages
// (persistMsg, for exected long-running messages - e.g. "saving..." sometimes disappeared before "saved" came.)
// (Stolen from IBdM/IBG/Chronarium)
function utilGenUI() {
	this._transientMsg_messages = {};
	//this._debugMode = false;
};

/* shinkOut, growIn, fadeOut, fadeIn */
utilGenUI.prototype.shrinkOut = function($btn, callback) {
	$btn.css("transition-duration", "0.4s");
	$btn.css("transition-property", "transform opacity");
	//$btn.css("opacity", "0.5"); // this breaks the animation, for some reason.
	$btn.css("transform", "scale(0,0)");
	setTimeout(function() {
		callback();
	}, 500);
}
utilGenUI.prototype.growIn = function($btn, callback) {
	$btn.css("transition-duration", "0");
	$btn.css("opacity", "0.01");
	$btn.css("transform", "scale(0.5,0.5)");
	setTimeout(function() {
		$btn.css("transition-duration", "0.6s");
		$btn.css("transition-property", "opacity transform");
		$btn.css("opacity", "1");
		$btn.css("transform", "scale(1,1)");
		setTimeout(function() {
			if (callback)
				callback();
		}, 600);
	}, 100);
}
utilGenUI.prototype.fadeOut = function($btn, callback) {
	$btn.css("transition-duration", "0.4s");
	$btn.css("transition-property", "opacity");
	$btn.css("opacity", "0");
	setTimeout(function() {
		callback();
	}, 500);
}
utilGenUI.prototype.fadeIn = function($btn, callback) {
	$btn.css("transition-duration", "0");
	$btn.css("opacity", "0.01");
	setTimeout(function() {
		$btn.css("transition-duration", "0.6s");
		$btn.css("transition-property", "opacity transform");
		$btn.css("opacity", "1");
		setTimeout(function() {
			if (callback)
				callback();
		}, 600);
	}, 100);
}


utilGenUI.prototype.transientMsg = function(id, msgText, persistMsg) {
	var self = this;
	var appendToClass = "transientMessages";
	if (msgText === undefined)
		alert("No msgText: " + id);
	
	var $msg = null;
	// If id exists, clear timer, update text.
	if (id in this._transientMsg_messages) {
		$msg = this._transientMsg_messages[id];
		clearTimeout($msg.timerHandle);
		$msg.html(msgText);
		if (msgText == "") {
			$msg.remove();
			return;
		}
	}
	// If DNE, create & add to DOM.
	else if (msgText != "") {
		$msg = this._transientMsg_messages[id] = $("<div class='message'>" + msgText + "</div>");
		$msg.appendTo("." + appendToClass);
		self.fadeIn($msg, function(){});
	}
	// Renew timer.
	if ($msg && persistMsg !== true) {
		$msg.timerHandle = setTimeout( function() {
			self.fadeOut($msg, function(){
				$msg.remove();
				delete self._transientMsg_messages[id];
			});
		}, 3000);
	}
}
// DEPRECATED support (old casing)
utilGenUI.prototype.TransientMsg = function(id, msgText, persistMsg) {
	console.warn("utilGenUI.TransientMsg DEPRECATED.");
	return this.transientMsg(id, msgText, persistMsg);
}

/*utilGenUI.prototype.DebugMsg = function(id, msgText, persistMsg) {
	if (this._debugMode) {
		this.TransientMsg(id, msgText, persistMsg);
	}
}*/


utilGenUI.prototype.alertMsg = function(message, dialogTitle, callback) {
	// (Requires plugin "cordova-plugin-dialogs")
	if (navigator.notification && navigator.notification.alert) {
		navigator.notification.alert(message, callback, dialogTitle ? dialogTitle : "Notice");
	}
	else {
		alert(message);
		if (callback)
			callback();
	}
}
// DEPRECATED support
utilGenUI.prototype.alert = function(message, dialogTitle, callback) {
	console.warn("utilGenUI.alert DEPRECATED.");
	this.alertMsg(message, dialogTitle, callback);
}

